Debian Bug report logs - #649094
bi-arch path support in dpkg-cross

Package: dpkg-cross; Maintainer for dpkg-cross is Debian Embedded Group <debian-embedded@lists.debian.org>; Source for dpkg-cross is src:dpkg-cross.

Reported by: Vincent Danjean <vdanjean@debian.org>

Date: Thu, 17 Nov 2011 15:42:02 UTC

Severity: wishlist

Tags: moreinfo

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-embedded@lists.debian.org, Neil Williams <codehelp@debian.org>:
Bug#649094; Package xapt. (Thu, 17 Nov 2011 15:42:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Danjean <vdanjean@debian.org>:
New Bug report received and forwarded. Copy sent to debian-embedded@lists.debian.org, Neil Williams <codehelp@debian.org>. (Thu, 17 Nov 2011 15:42:18 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Vincent Danjean <vdanjean@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: xapt: paths not fixed in libc.so in cross packages
Date: Thu, 17 Nov 2011 16:37:47 +0100
[Message part 1 (text/plain, inline)]
Package: xapt
Version: 2.2.17
Severity: normal

  Hi,

  I'm trying to build a debian package of a mipsel cross-compiler.
To do that, I build a binutils for my target, then I install
required cross library with xapt and finally I try to build the cross-compiler
itself.
  The last part fails within sid and testing. It took me some times, but I
found the problem. xapt correctly fix paths in lib/libc.so but not
in lib{32,64}/libc.so (ie these files refers to /lib{32,64}/* and
/usr/lib{32,64}/* files instead of /usr/mipsel-linux-gnu/lib{32,64})

  Manually changing these paths allow me to go further in the compilation of
the cross compiler (but not yet to the end :-( )

  You will find in attachment the script I use to build my cross-compiler.

  Regards,
    Vincent


-- System Information:
Debian Release: wheezy/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'testing'), (500, 'stable'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 3.0.0-2-amd64 (SMP w/8 CPU cores)
Locale: LANG=fr_FR.UTF-8, LC_CTYPE=fr_FR.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages xapt depends on:
ii  apt                      0.8.15.9           
ii  dpkg-cross               2.6.5              
ii  dpkg-dev                 1.16.2~50.gbp921bea
ii  libconfig-inifiles-perl  2.68-1             
ii  libdpkg-perl             1.16.2~50.gbp921bea
ii  liblocale-gettext-perl   1.05-7             
ii  perl                     5.12.4-6           

xapt recommends no packages.

xapt suggests no packages.

-- no debconf information
[README.Debian (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Neil Williams <codehelp@debian.org>:
Bug#649094; Package xapt. (Thu, 17 Nov 2011 15:57:14 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Danjean <vdanjean@debian.org>:
Extra info received and forwarded to list. Copy sent to Neil Williams <codehelp@debian.org>. (Thu, 17 Nov 2011 15:57:15 GMT) Full text and rfc822 format available.

Message #10 received at 649094@bugs.debian.org (full text, mbox):

From: Vincent Danjean <vdanjean@debian.org>
To: 649094@bugs.debian.org
Subject: Re: Bug#649094: xapt: paths not fixed in libc.so in cross packages
Date: Thu, 17 Nov 2011 16:54:38 +0100
Le 17/11/2011 16:37, Vincent Danjean a écrit :
>    Hi,
>
>    I'm trying to build a debian package of a mipsel cross-compiler.
> To do that, I build a binutils for my target, then I install
> required cross library with xapt and finally I try to build the cross-compiler
> itself.
>    The last part fails within sid and testing. It took me some times, but I
> found the problem. xapt correctly fix paths in lib/libc.so but not
> in lib{32,64}/libc.so (ie these files refers to /lib{32,64}/* and
> /usr/lib{32,64}/* files instead of /usr/mipsel-linux-gnu/lib{32,64})

Note that /usr/mipsel-linux-gnu/lib32/libc.so comes from libc6-dev-mipsn32-mipsel-cross
and /usr/mipsel-linux-gnu/lib64/libc.so comes from libc6-dev-mips64-mipsel-cross

/usr/mipsel-linux-gnu/lib/libc.so (who has its paths fixed) comes from
libc6-dev-mipsel-cross

>    Manually changing these paths allow me to go further in the compilation of
> the cross compiler (but not yet to the end :-( )
>
>    You will find in attachment the script I use to build my cross-compiler.
>
>    Regards,
>      Vincent

-- 
Vincent Danjean       GPG key ID 0x9D025E87         vdanjean@debian.org
GPG key fingerprint: FC95 08A6 854D DB48 4B9A  8A94 0BF7 7867 9D02 5E87
Unofficial pkgs: http://moais.imag.fr/membres/vincent.danjean/deb.html
APT repo:  deb http://people.debian.org/~vdanjean/debian unstable main





Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#649094; Package xapt. (Thu, 17 Nov 2011 16:27:56 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. (Thu, 17 Nov 2011 16:27:56 GMT) Full text and rfc822 format available.

Message #15 received at 649094@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: Vincent Danjean <vdanjean@debian.org>, 649094@bugs.debian.org
Cc: control@bugs.debian.org
Subject: Re: Bug#649094: xapt: paths not fixed in libc.so in cross packages
Date: Thu, 17 Nov 2011 16:23:30 +0000
[Message part 1 (text/plain, inline)]
reassign 649094 dpkg-cross
notfound 649094 2.2.17
severity 649094 wishlist
retitle 649094 bi-arch path support in dpkg-cross
tag 649094 wontfix
quit

On Thu, 17 Nov 2011 16:37:47 +0100
Vincent Danjean <vdanjean@debian.org> wrote:

> Package: xapt
> Version: 2.2.17
> Severity: normal

xapt only downloads the packages. Anything after that happens with
dpkg-cross which has a limited future in Debian as it is completely
incompatible with Multiarch.

I wouldn't recommend doing any new work based on dpkg-cross or xapt.
The future is Multiarch.

There is documentation already on how to build cross-compilers and
there is the buildcross package in experimental.

I see no need to fix this bug. You're re-inventing a script which
already exists in Debian and you are using outdated tools to do it.
It's a hiding to nothing and a completely wasted effort. Talk to the
debian-embedded people and maintainer of buildcross.

Right now, the only practical cross-compiler methods are all based on
stable. Everything in testing and unstable is just too broken to use.

-- 


Neil Williams
=============
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Bug reassigned from package 'xapt' to 'dpkg-cross'. Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Thu, 17 Nov 2011 16:28:05 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions emdebian-crush/2.2.17. Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Thu, 17 Nov 2011 16:28:06 GMT) Full text and rfc822 format available.

Severity set to 'wishlist' from 'normal' Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Thu, 17 Nov 2011 16:28:06 GMT) Full text and rfc822 format available.

Changed Bug title to 'bi-arch path support in dpkg-cross' from 'xapt: paths not fixed in libc.so in cross packages' Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Thu, 17 Nov 2011 16:28:07 GMT) Full text and rfc822 format available.

Added tag(s) wontfix. Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Thu, 17 Nov 2011 16:28:08 GMT) Full text and rfc822 format available.

Information stored :
Bug#649094; Package dpkg-cross. (Thu, 17 Nov 2011 17:03:17 GMT) Full text and rfc822 format available.

Acknowledgement sent to Hector Oron <zumbi@debian.org>:
Extra info received and filed, but not forwarded. (Thu, 17 Nov 2011 17:03:18 GMT) Full text and rfc822 format available.

Message #30 received at 649094-quiet@bugs.debian.org (full text, mbox):

From: Hector Oron <zumbi@debian.org>
To: Vincent Danjean <vdanjean@debian.org>, 649094-quiet@bugs.debian.org
Subject: Re: Bug#649094: xapt: paths not fixed in libc.so in cross packages
Date: Thu, 17 Nov 2011 16:59:25 +0000
[Message part 1 (text/plain, inline)]
Hello Vincent,

On Thu, Nov 17, 2011 at 04:23:30PM +0000, Neil Williams wrote:

> Vincent Danjean <vdanjean@debian.org> wrote:
 
> > Package: xapt
> > Version: 2.2.17
> > Severity: normal
 
> I see no need to fix this bug. You're re-inventing a script which
> already exists in Debian and you are using outdated tools to do it.
> It's a hiding to nothing and a completely wasted effort. Talk to the
> debian-embedded people and maintainer of buildcross.
> 
> Right now, the only practical cross-compiler methods are all based on
> stable. Everything in testing and unstable is just too broken to use.

I am also getting broken tri-arch cross compilers on mips(el):
  <http://emdebian.org/~zumbi/toolchain/sid/amd64/logs/amd64-mips-gcc-4.6.log>

I usually wget the package and dpkg-cross them with -M switch, that should
work around the issue and place the objects in the right place.

When building multilib cross compiler, it would be very useful if cross ld
would pick up the right objects. If you find the way before I do, let me know.

Cheers,
-- 
 Héctor Orón

"Our Sun unleashes tremendous flares expelling hot gas into the Solar System, which one day will disconnect us."

-- Day DVB-T stop working nicely
Video flare: http://antwrp.gsfc.nasa.gov/apod/ap100510.html
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Embedded Group <debian-embedded@lists.debian.org>:
Bug#649094; Package dpkg-cross. (Fri, 18 Nov 2011 09:09:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Danjean <vdanjean@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Embedded Group <debian-embedded@lists.debian.org>. (Fri, 18 Nov 2011 09:09:13 GMT) Full text and rfc822 format available.

Message #35 received at 649094@bugs.debian.org (full text, mbox):

From: Vincent Danjean <vdanjean@debian.org>
To: Hector Oron <zumbi@debian.org>
Cc: 649094@bugs.debian.org
Subject: Re: Bug#649094: xapt: paths not fixed in libc.so in cross packages
Date: Fri, 18 Nov 2011 10:06:58 +0100
Le 17/11/2011 17:59, Hector Oron a écrit :
> Hello Vincent,
>
> On Thu, Nov 17, 2011 at 04:23:30PM +0000, Neil Williams wrote:
>
>> Vincent Danjean<vdanjean@debian.org>  wrote:
>
>>> Package: xapt
>>> Version: 2.2.17
>>> Severity: normal
>
>> I see no need to fix this bug. You're re-inventing a script which
>> already exists in Debian and you are using outdated tools to do it.
>> It's a hiding to nothing and a completely wasted effort. Talk to the
>> debian-embedded people and maintainer of buildcross.
>>
>> Right now, the only practical cross-compiler methods are all based on
>> stable. Everything in testing and unstable is just too broken to use.
>
> I am also getting broken tri-arch cross compilers on mips(el):
>    <http://emdebian.org/~zumbi/toolchain/sid/amd64/logs/amd64-mips-gcc-4.6.log>
>
> I usually wget the package and dpkg-cross them with -M switch, that should
> work around the issue and place the objects in the right place.

In my case, the objects where in the right place (/usr/mipsel...) but the
contents of the /usr/mipsel.../lib{32,64}/libc.so (that is a texte file)
was not correctly updated. They refer to /lib{32,64}/* objects

  Regards,
    Vincent

> When building multilib cross compiler, it would be very useful if cross ld
> would pick up the right objects. If you find the way before I do, let me know.
>
> Cheers,


-- 
Vincent Danjean          Adresse: Laboratoire d'Informatique de Grenoble
Téléphone:  +33 4 76 61 20 11            ENSIMAG - antenne de Montbonnot
Fax:        +33 4 76 61 20 99            ZIRST 51, avenue Jean Kuntzmann
Email: Vincent.Danjean@imag.fr           38330 Montbonnot Saint Martin




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Embedded Group <debian-embedded@lists.debian.org>:
Bug#649094; Package dpkg-cross. (Fri, 18 Nov 2011 10:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Vincent Danjean <vdanjean@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Embedded Group <debian-embedded@lists.debian.org>. (Fri, 18 Nov 2011 10:03:07 GMT) Full text and rfc822 format available.

Message #40 received at 649094@bugs.debian.org (full text, mbox):

From: Vincent Danjean <vdanjean@debian.org>
To: Neil Williams <codehelp@debian.org>
Cc: 649094@bugs.debian.org
Subject: Re: Bug#649094: xapt: paths not fixed in libc.so in cross packages
Date: Fri, 18 Nov 2011 11:00:59 +0100
Le 17/11/2011 17:23, Neil Williams a écrit :
> xapt only downloads the packages. Anything after that happens with
> dpkg-cross which has a limited future in Debian as it is completely
> incompatible with Multiarch.
>
> I wouldn't recommend doing any new work based on dpkg-cross or xapt.
> The future is Multiarch.

I know but I found nothing in the wiki nor in packages telling how
to build a cross compiler with Multiarch..

> There is documentation already on how to build cross-compilers and
> there is the buildcross package in experimental.

Sorry. I looked at various place (mostly current packages and
http://wiki.debian.org/BuildingCrossCompilers ).
  I missed the reference at the buildcross package in the first
lines of the wiki page but I tried to follow what it written next
in this wiki page. My 'script' was just the list of commands
explained in this wiki.

> I see no need to fix this bug. You're re-inventing a script which
> already exists in Debian and you are using outdated tools to do it.
> It's a hiding to nothing and a completely wasted effort. Talk to the
> debian-embedded people and maintainer of buildcross.


> Right now, the only practical cross-compiler methods are all based on
> stable. Everything in testing and unstable is just too broken to use.

Ok. So I will try to build a mips cross-compiler from stable as I'm doing
know, ie with old tools (I need a cross compiler for my students quickly).

I will also try the buildcross package in experimental as this is
the future.

  Regards,
    Vincent




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Embedded Group <debian-embedded@lists.debian.org>:
Bug#649094; Package dpkg-cross. (Fri, 18 Nov 2011 11:36:16 GMT) Full text and rfc822 format available.

Acknowledgement sent to Hector Oron <hector.oron@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Embedded Group <debian-embedded@lists.debian.org>. (Fri, 18 Nov 2011 11:36:21 GMT) Full text and rfc822 format available.

Message #45 received at 649094@bugs.debian.org (full text, mbox):

From: Hector Oron <hector.oron@gmail.com>
To: Vincent Danjean <vdanjean@debian.org>, 649094@bugs.debian.org
Cc: debian embedded <debian-embedded@lists.debian.org>
Subject: Re: Bug#649094: xapt: paths not fixed in libc.so in cross packages
Date: Fri, 18 Nov 2011 11:35:31 +0000
Hello,

2011/11/18 Vincent Danjean <vdanjean@debian.org>:

> Ok. So I will try to build a mips cross-compiler from stable as I'm doing
> know, ie with old tools (I need a cross compiler for my students quickly).

Sounds sensible and recommended.

> I will also try the buildcross package in experimental as this is
> the future.

No, buildcross is not the future. Currently there is a Debian
multiarch transition and cross tools need to be updated to cope with
multiarch. The future would be getting them into proper Debian.
Marcin, as par of its Linaro job, has been contributing some packages
which currently build properly on armel and armhf but fail on any
other architectures (at least for me) with the bug you are reporting.

For Emdebian future, I personally would like to switch to sysroot
enabled toolchains, so you can easily cross compile your application
and link against the libraries found in a sysroot directory, that
could easily be created by tools like debootstrap or multistrap. This
way, you are not forced to link against your system libraries, as your
target device could be running libraries totally different than your
development host.

So, Debian future is multiarch enabled cross toolchains. And Emdebian
proposed future are sysroot enabled toolchains.
Then dpkg-cross, xapt, .. and other tools will be removed from Debian.
For Emdebian, I would also wonder if it would make sense to create and
Android toolchain and uClibc cross toolchain, but time is limited and
there is not a real incentive yet (at least to me) to get them up and
running, so any contributions are more than welcome.

Also note I try to keep more or less up to date this wiki page:
 <http://wiki.debian.org/EmdebianToolchain>

Kind regards,
-- 
 Héctor Orón  -.. . -... .. .- -.   -.. . ...- . .-.. --- .--. . .-.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Embedded Group <debian-embedded@lists.debian.org>:
Bug#649094; Package dpkg-cross. (Mon, 17 Dec 2012 17:33:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Matthias Klose <doko@ubuntu.com>:
Extra info received and forwarded to list. Copy sent to Debian Embedded Group <debian-embedded@lists.debian.org>. (Mon, 17 Dec 2012 17:33:06 GMT) Full text and rfc822 format available.

Message #50 received at 649094@bugs.debian.org (full text, mbox):

From: Matthias Klose <doko@ubuntu.com>
To: 649094@bugs.debian.org
Subject: fix 64bit biarch linker scripts
Date: Mon, 17 Dec 2012 18:29:32 +0100
[Message part 1 (text/plain, inline)]
tags 649094 + patch
thanks

at least for 64bit biarch

dpkg-cross (2.6.9ubuntu2) raring; urgency=low

  * Handle biarch linker scripts - LP: #1090800

 -- Marcin Juszkiewicz <marcin.juszkiewicz@linaro.org>   Mon, 17 Dec 2012
15:01:29 +0100

[plain.txt (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Embedded Group <debian-embedded@lists.debian.org>:
Bug#649094; Package dpkg-cross. (Wed, 19 Dec 2012 10:15:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Legion Fox <id4fox@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Embedded Group <debian-embedded@lists.debian.org>. (Wed, 19 Dec 2012 10:15:06 GMT) Full text and rfc822 format available.

Message #55 received at 649094@bugs.debian.org (full text, mbox):

From: Legion Fox <id4fox@gmail.com>
To: Matthias Klose <doko@ubuntu.com>, 649094@bugs.debian.org
Subject: Re: Bug#649094: fix 64bit biarch linker scripts
Date: Wed, 19 Dec 2012 18:13:23 +0800
[Message part 1 (text/plain, inline)]
Thanks for your help !
I will try it and response on my question!
:- )


2012/12/18 Matthias Klose <doko@ubuntu.com>

> tags 649094 + patch
> thanks
>
> at least for 64bit biarch
>
> dpkg-cross (2.6.9ubuntu2) raring; urgency=low
>
>   * Handle biarch linker scripts - LP: #1090800
>
>  -- Marcin Juszkiewicz <marcin.juszkiewicz@linaro.org>   Mon, 17 Dec 2012
> 15:01:29 +0100
>
>
[Message part 2 (text/html, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Embedded Group <debian-embedded@lists.debian.org>:
Bug#649094; Package dpkg-cross. (Tue, 07 May 2013 15:27:18 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Embedded Group <debian-embedded@lists.debian.org>. (Tue, 07 May 2013 15:27:18 GMT) Full text and rfc822 format available.

Message #60 received at 649094@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 649094@bugs.debian.org
Cc: Vincent Danjean <vdanjean@debian.org>, Matthias Klose <doko@ubuntu.com>, control@bugs.debian.org
Subject: Testing dpkg-cross bi-arch conversion for #649094
Date: Tue, 7 May 2013 16:26:13 +0100
[Message part 1 (text/plain, inline)]
tag 649094 - wontfix
tag 649094 + moreinfo
thanks

I've applied the patch locally for bi-arch conversion but I can't
produce any difference in the behaviour of dpkg-cross for the bi-arch
packages I tested.

Which packages are actually demonstrating the problem and what command
line was given to either xapt (originally) or dpkg-cross to reproduce
the problem and test the patch?

Also, what version of dpkg-cross was tested? At the time that the
original bug was opened against xapt 2.2.17 in November 2011, 2.2.18
was already available in unstable and testing.

The quoted 2.6.9ubuntu2 version from raring and the powerpc.deb
attached to the LP bug produce the same output for me with or without
the patch:
./usr/powerpc-linux-gnu/lib64/libc.so

dpkg-cross 2.6.10 (experimental)

I need to be able to verify the bug and the effect of the patch before
I can upload a new version to bring the changes from experimental into
unstable.

-- 


Neil Williams
=============
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Removed tag(s) wontfix. Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Tue, 07 May 2013 15:27:21 GMT) Full text and rfc822 format available.

Added tag(s) moreinfo. Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Tue, 07 May 2013 15:27:21 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 25 01:44:40 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.